'''
Default settings
'''

from .itemobj import i

__all__ = 'ITEMS',


ITEMS = (
    i('Deku Stick Capacity', (0, 0), ('Deku Sticks',)*3,
       tuple(zip(('stick',)*3, (10, 20, 30))),
      link=(('Buy Deku Stick (1)', 1),)),
    i('Slingshot', (0, 1), ('Slingshot',)*3,
       tuple(zip(('slingshot',)*3, (30, 40, 50)))),
    i('Boomerang', (0, 2), ('Boomerang',), ('boomerang',)),
    i('Bottle', (0, 3), ('Bottles',)*4, tuple(zip(('bottle',)*4, range(1, 5)))),
    i('Deku Nut Capacity', (1, 0), ('Deku Nuts',)*3,
      tuple(zip(('nut',)*3, (20, 30, 40)))),
    i('Ocarina', (1, 1), ('Fairy Ocarina', 'Ocarina of Time'),
       ('fairyocarina', 'ocarina')),
    i('Lens of Truth', (1, 2), ('Lens of Truth',), ('lens',)),
    i('Bottle with Letter', (1, 3), ("Ruto's Letter",),
       ('bottle_letter',)),
    i('Bomb Bag', (2, 0), ('Bombs',)*3,
       tuple(zip(('bomb',)*3, (20, 30, 40)))),
    i('Bombchus', (2, 1), ('Bombchus',), ('bombchu',)),
    i('Magic Bean', (2, 2), ('Magic Beans',)*10,
       tuple(zip(('bean',)*10, range(1, 11)))),
    i('Bottle with Big Poe', (2, 3), ('Big Poes',)*10,
       tuple(zip(('bottle_bigpoe',)*10, range(1, 11)))),
    i('Bow', (3, 0), ('Bow',)*3,
       tuple(zip(('bow',)*3, (30, 40, 50)))),
    i('Progressive Hookshot', (3, 1), ('Hookshot', 'Longshot'),
       ('hookshot', 'longshot')),
    i('Hammer', (3, 2), ('Megaton Hammer',), ('hammer',)),
    i('Gold Skulltula Token', (3, 3), ('Gold Skulltula Token',)*100,
      tuple(zip(('skulltula_token',)*101, range(1, 101)))),
    i('Fire Arrows', (4, 0), ('Fire Arrows',), ('firearrow',)),
    i('Ice Arrows', (4, 1), ('Ice Arrows',), ('icearrow',)),
    i('Light Arrows', (4, 2), ('Light Arrows',), ('lightarrow',)),
    i('Weird Egg', (4, 3),
      ('Weird Egg (Child)', "Zelda's Letter", 'Mask Quest', 'Keaton Mask',
       'Mask Quest', 'Skull Mask', 'Mask Quest', 'Spooky Mask', 'Mask Quest',
       'Bunny Hood', 'Mask Quest', 'Mask of Truth'),
      ('egg', 'letter', 'sold_out', 'keaton', 'sold_out', 'skull', 'sold_out',
       'spooky', 'sold_out', 'bunny', 'sold_out', 'truth'),
      link=(('Zeldas Letter', 2),)),
    i('Dins Fire', (5, 0), ("Din's Fire",), ('din',)),
    i('Farores Wind', (5, 1), ("Farore's Wind",), ('farore',)),
    i('Nayrus Love', (5, 2), ("Nayru's Love",), ('nayru',)),
    i('Pocket Egg', (5, 3),
      ('Pocket Egg (Adult)', 'Pocket Cucco', 'Cojiro', 'Odd Mushroom',
       'Odd Potion', "Poacher's Saw", "Broken Goron's Sword", 'Prescription',
       'Eyeball Frog', "World's Finest Eye Drops", 'Claim Check', 'Done'),
      ('egg', 'cucco', 'cojiro', 'mushroom', 'medicine', 'saw', 'broken_sword',
       'perscription', 'frog', 'eyedrops', 'claim', 'sword3'),
      link=(('Pocket Cucco', 2), ('Cojiro', 3), ('Odd Mushroom', 4),
            ('Odd Potion', 5), ('Poachers Saw', 6), ('Broken Sword', 7),
            ('Prescription', 8), ('Eyeball Frog', 9), ('Eyedrops', 10),
            ('Claim Check', 11))),
    i('Kokiri Sword', (0, 4), ('Kokiri Sword',), ('sword1',)),
    i('Master Sword', (1, 4), ('Master Sword',), ('sword2',)),
    i('Biggoron Sword', (2, 4), ('Biggoron Sword',), ('sword3',)),
    i('Deku Shield', (3, 4), ('Deku Shield',), ('shield1',),
      link=(('Buy Deku Shield', 1),)),
    i('Hylian Shield', (4, 4), ('Hylian Shield',), ('shield2',)),
    i('Mirror Shield', (5, 4), ('Mirror Shield',), ('shield3',)),
    i('Goron Tunic', (0, 5), ('Goron Tunic',), ('redtunic',)),
    i('Zora Tunic', (1, 5), ('Zora Tunic',), ('bluetunic',)),
    i('Iron Boots', (2, 5), ('Iron Boots',), ('ironboots',)),
    i('Hover Boots', (3, 5), ('Hover Boots',), ('hoverboots',)),
    i('Small Key (Gerudo Fortress)', (4, 5), ('Rescued Carpenters',)*4,
      tuple(zip(('saw',)*4, range(1, 5))),
      link=(('Carpenter Rescue', 4),)),
    i('Gerudo Membership Card', (5, 5), ('Gerudo Membership Card',),
      ('gerudocard',)),
    i('Progressive Strength Upgrade', (0, 6),
      ("Goron's Bracelet", 'Silver Gauntlets', 'Golden Gauntlets'),
      ('lift1', 'lift2', 'lift3')),
    i('Progressive Scale', (1, 6), ('Silver Scale', 'Golden Scale'),
      ('scale1', 'scale2')),
    i('Progressive Wallet', (2, 6),
      ("Child's Wallet", "Adult's Wallet", "Giant's Wallet", "Tycoon's Wallet"),
      ('wallet', 'wallet1', 'wallet2', 'wallet3'), default=1),
    i('Magic Meter', (3, 6), ('Magic', 'Double Magic'), ('magic1', 'magic2')),
    i('Stone of Agony', (4, 6), ('Stone of Agony',), ('agony',)),
    i('Zeldas Lullaby', (0, 7), ("Zelda's Lullaby",), ('zelda_colored',)),
    i('Eponas Song', (1, 7), ("Epona's Song",), ('epona_colored',),
      link=(('Epona', 1),)),
    i('Sarias Song', (2, 7), ("Saria's Song",), ('saria_colored',)),
    i('Suns Song', (3, 7), ("Sun's Song",), ('sun_colored',)),
    i('Song of Time', (4, 7), ('Song of Time',), ('time_colored',)),
    i('Song of Storms', (5, 7), ('Song of Storms',), ('storms_colored',)),
    i('Minuet of Forest', (0, 8), ('Minuet of Forest',), ('minuet',)),
    i('Bolero of Fire', (1, 8), ('Bolero of Fire',), ('bolero',)),
    i('Serenade of Water', (2, 8), ('Serenade of Water',), ('serenade',)),
    i('Requiem of Spirit', (3, 8), ('Requiem of Spirit',), ('requiem',)),
    i('Nocturne of Shadow', (4, 8), ('Nocturne of Shadow',), ('nocturne',)),
    i('Prelude of Light', (5, 8), ('Prelude of Light',), ('prelude',)),
    i('Kokiri Emerald', (0, 9), ("Kokiri's Emerald",), ('emerald',)),
    i('Goron Ruby', (1, 9), ("Goron's Ruby",), ('ruby',)),
    i('Zora Sapphire', (2, 9), ("Zora's Sapphire",), ('sapphire',)),
    i('Light Medallion', (0, 10), ('Light Medallion',), ('lightmedallion',)),
    i('Forest Medallion', (1, 10), ('Forest Medallion',), ('forestmedallion',)),
    i('Fire Medallion', (2, 10), ('Fire Medallion',), ('firemedallion',)),
    i('Water Medallion', (3, 10), ('Water Medallion',), ('watermedallion',)),
    i('Shadow Medallion', (4, 10), ('Shadow Medallion',), ('shadowmedallion',)),
    i('Spirit Medallion', (5, 10), ('Spirit Medallion',), ('spiritmedallion',)),
    i('Fairy Ocarina', (), (), ()),
    i('Ocarina of Time', (), (), ()),
    i('Bottle with Milk', (), (), ()),
    i('Bottle with Red Potion', (), (), ()),
    i('Bottle with Green Potion', (), (), ()),
    i('Bottle with Fairy', (), (), ()),
    i('Bottle with Fish', (), (), ()),
    i('Bottle with Blue Fire', (), (), ()),
    i('Bottle with Bugs', (), (), ()),
    i('Bottle with Poe', (), (), ()),
    i('Zeldas Letter', (), ('<stub>',), ('<stub>',)),
    i('Pocket Cucco', (), ('<stub>',), ('<stub>',)),
    i('Cojiro', (), ('<stub>',), ('<stub>',)),
    i('Odd Mushroom', (), ('<stub>',), ('<stub>',)),
    i('Odd Potion', (), ('<stub>',), ('<stub>',)),
    i('Poachers Saw', (), ('<stub>',), ('<stub>',)),
    i('Broken Sword', (), ('<stub>',), ('<stub>',)),
    i('Prescription', (), ('<stub>',), ('<stub>',)),
    i('Eyeball Frog', (), ('<stub>',), ('<stub>',)),
    i('Eyedrops', (), ('<stub>',), ('<stub>',)),
    i('Claim Check', (), ('<stub>',), ('<stub>',)),
    i('Double Defense', (), (), ()),
    i('Bombchus (5)', (), (), ()),
    i('Bombchus (10)', (), (), ()),
    i('Bombchus (20)', (), (), ()),
    i('Boss Key', (), (), ()),
    i('Small Key', (), (), ()),
    i('Epona', (), ('<stub>',), ('<stub>',)),
    i('Carpenter Rescue', (), ('<stub>',), ('<stub>',)),
    i('Deku Stick Drop', (), (), ()),
    i('Deku Nut Drop', (), (), ()),
    i('Forest Trial Clear', (), (), (), default=1),
    i('Fire Trial Clear', (), (), (), default=1),
    i('Water Trial Clear', (), (), (), default=1),
    i('Shadow Trial Clear', (), (), (), default=1),
    i('Spirit Trial Clear', (), (), (), default=1),
    i('Light Trial Clear', (), (), (), default=1),
    i('Triforce', (), (), ()),
    i('Buy Deku Nut (5)', (), (), ()),
    i('Buy Deku Nut (10)', (), (), ()),
    i('Buy Deku Stick (1)', (), ('<stub>',), ('<stub>',)),
    i('Buy Deku Shield', (), ('<stub>',), ('<stub>',)),
    i('Buy Goron Tunic', (), (), ()),
    i('Buy Zora Tunic', (), (), ()),
    i('Buy Bombchu (10)', (), (), ()),
    i('Buy Bombchu (20)', (), (), ()),
    i('Buy Bombchu (5)', (), (), ()),
    i('Buy Blue Fire', (), (), ()),
    i('Buy Bottle Bug', (), (), ()),
)
