def shop_address(shop_id, shelf_id):
    return 0xC71ED0 + (0x40 * shop_id) + (0x08 * shelf_id)

#   Location:                                           Type          Scene  Default   Hint                  Addresses
location_table = {
    "Kokiri Sword Chest":                              ("Chest",       0x55,  0x00, "Kokiri Forest",          None),
    "Mido Chest Top Left":                             ("Chest",       0x28,  0x00, "Kokiri Forest",          None),
    "Mido Chest Top Right":                            ("Chest",       0x28,  0x01, "Kokiri Forest",          None),
    "Mido Chest Bottom Left":                          ("Chest",       0x28,  0x02, "Kokiri Forest",          None),
    "Mido Chest Bottom Right":                         ("Chest",       0x28,  0x03, "Kokiri Forest",          None),
    "Shield Grave Chest":                              ("Chest",       0x40,  0x00, "the Graveyard",          None),
    "Heart Piece Grave Chest":                         ("Chest",       0x3F,  0x00, "the Graveyard",          None),
    "Composer Grave Chest":                            ("Chest",       0x41,  0x00, "the Graveyard",          None),
    "Death Mountain Bombable Chest":                   ("Chest",       0x60,  0x01, "Death Mountain Trail",   None),
    "Goron City Leftmost Maze Chest":                  ("Chest",       0x62,  0x00, "Goron City",             None),
    "Goron City Right Maze Chest":                     ("Chest",       0x62,  0x01, "Goron City",             None),
    "Goron City Left Maze Chest":                      ("Chest",       0x62,  0x02, "Goron City",             None),
    "Zoras Domain Torch Run":                          ("Chest",       0x58,  0x00, "Zora's Domain",          None),
    "Hookshot Chest":                                  ("Chest",       0x48,  0x00, "the Graveyard",          None),
    "Gerudo Valley Hammer Rocks Chest":                ("Chest",       0x5A,  0x00, "Gerudo Valley",          None),
    "Gerudo Fortress Rooftop Chest":                   ("Chest",       0x5D,  0x00, "Gerudo's Fortress",      None),
    "Haunted Wasteland Structure Chest":               ("Chest",       0x5E,  0x00, "Haunted Wasteland",      None),
    "Redead Grotto Chest":                             ("Chest",       0x3E,  0x0A, "Kakariko Village",       None),
    "Wolfos Grotto Chest":                             ("Chest",       0x3E,  0x11, "Sacred Forest Meadow",   None),
    "Silver Gauntlets Chest":                          ("Chest",       0x5C,  0x0B, "Desert Colossus",        None),
    "Mirror Shield Chest":                             ("Chest",       0x5C,  0x09, "Desert Colossus",        None),
    "Field West Castle Town Grotto Chest":             ("Chest",       0x3E,  0x00, "Hyrule Field",           None),
    "Remote Southern Grotto Chest":                    ("Chest",       0x3E,  0x02, "Hyrule Field",           None),
    "Field Near Lake Outside Fence Grotto Chest":      ("Chest",       0x3E,  0x03, "Hyrule Field",           None),
    "Kakariko Back Grotto Chest":                      ("Chest",       0x3E,  0x08, "Kakariko Village",       None),
    "Zora River Plateau Open Grotto Chest":            ("Chest",       0x3E,  0x09, "Zora's River",           None),
    "Kokiri Forest Storms Grotto Chest":               ("Chest",       0x3E,  0x0C, "Kokiri Forest",          None),
    "Lost Woods Generic Grotto Chest":                 ("Chest",       0x3E,  0x14, "the Lost Woods",         None),
    "Mountain Storms Grotto Chest":                    ("Chest",       0x3E,  0x17, "Death Mountain Trail",   None),
    "Top of Crater Grotto Chest":                      ("Chest",       0x3E,  0x1A, "Death Mountain Crater",  None),
    "Treasure Chest Game":                             ("Chest",       0x10,  0x0A, "the Market",             None),

    "Zelda":                                           ("Cutscene",    0xFF,  0x01, "Temple of Time",         None),
    "Gift from Saria":                                 ("Cutscene",    0xFF,  0x02, "the Lost Woods",         None),
    "Zoras Fountain Fairy Reward":                     ("Cutscene",    0xFF,  0x10, "Zora's Fountain",        None),
    "Hyrule Castle Fairy Reward":                      ("Cutscene",    0xFF,  0x11, "Hyrule Castle",          None),
    "Desert Colossus Fairy Reward":                    ("Cutscene",    0xFF,  0x12, "Desert Colossus",        None),
    "Mountain Summit Fairy Reward":                    ("Cutscene",    0xFF,  0x13, "Death Mountain Trail",   None),
    "Crater Fairy Reward":                             ("Cutscene",    0xFF,  0x14, "Death Mountain Crater",  None),
    "Ganons Castle Fairy Reward":                      ("Cutscene",    0xFF,  0x15, "outside Ganon's Castle", None),

    "Sheik Forest Song":                               ("Song",        0xFF,  0x20, "Sacred Forest Meadow",   (0x20B0809, 0x20B0809)),
    "Sheik in Crater":                                 ("Song",        0xFF,  0x21, "Death Mountain Crater",  (0x224D7F1, 0x224D7F1)),
    "Sheik in Ice Cavern":                             ("Song",        0xFF,  0x22, "Ice Cavern",             (0x2BEC889, 0x2BEC889)),
    "Sheik at Colossus":                               ("Song",        0xFF,  0x23, "Desert Colossus",        (0x218C57D, 0x218C57D)),
    "Sheik in Kakariko":                               ("Song",        0xFF,  0x24, "Kakariko Village",       (0x2000FE1, 0x2000FE1)),
    "Sheik at Temple":                                 ("Song",        0xFF,  0x25, "Temple of Time",         (0x2531329, 0x2531329)),
    "Impa at Castle":                                  ("Song",        0xFF,  0x26, "Hyrule Castle",          (0x2E8E925, 0x2E8E925)),
    "Song from Malon":                                 ("Song",        0xFF,  0x27, "Lon Lon Ranch",          (0x0D7EB53, 0x0D7EBCF)),
    "Song from Saria":                                 ("Song",        0xFF,  0x28, "Sacred Forest Meadow",   (0x20B1DB1, 0x20B1DB1)),
    "Song from Composer Grave":                        ("Song",        0xFF,  0x29, "the Graveyard",          (0x332A871, 0x332A871)),
    "Song from Ocarina of Time":                       ("Song",        0xFF,  0x2A, "Hyrule Field",           (0x252FC89, 0x252FC89)),
    "Song at Windmill":                                ("Song",        0xFF,  0x2B, "Kakariko Village",       (0x0E42C07, 0x0E42B8B)),

    "Malon Egg":                                       ("NPC",         0x5F,  0x47, "Hyrule Castle",          None),
    "Zeldas Letter":                                   ("NPC",         None,  None, "Hyrule Castle",          None),
    "Darunias Joy":                                    ("NPC",         0x62,  0x54, "Goron City",             None),
    "Diving Minigame":                                 ("NPC",         0x58,  0x37, "Zora's Domain",          None),
    "Child Fishing":                                   ("NPC",         0x49,  0x3E, "Lake Hylia",             None),
    "Adult Fishing":                                   ("NPC",         0x49,  0x38, "Lake Hylia",             None),
    "Diving in the Lab":                               ("NPC",         0x38,  0x3E, "Lake Hylia",             None),
    "Link the Goron":                                  ("NPC",         0x62,  0x2C, "Goron City",             None),
    "King Zora Thawed":                                ("NPC",         0x58,  0x2D, "Zora's Domain",          None),
    "Bombchu Bowling Bomb Bag":                        ("NPC",         0x4B,  0x34, "the Market",             None),
    "Bombchu Bowling Piece of Heart":                  ("NPC",         0x4B,  0x3E, "the Market",             None),
    "Dog Lady":                                        ("NPC",         0x35,  0x3E, "the Market",             None),
    "Skull Kid":                                       ("NPC",         0x5B,  0x3E, "the Lost Woods",         None),
    "Ocarina Memory Game":                             ("NPC",         0x5B,  0x76, "the Lost Woods",         None),
    "10 Gold Skulltula Reward":                        ("NPC",         0x50,  0x45, "Kakariko Village",       None),
    "20 Gold Skulltula Reward":                        ("NPC",         0x50,  0x39, "Kakariko Village",       None),
    "30 Gold Skulltula Reward":                        ("NPC",         0x50,  0x46, "Kakariko Village",       None),
    "40 Gold Skulltula Reward":                        ("NPC",         0x50,  0x03, "Kakariko Village",       None),
    "50 Gold Skulltula Reward":                        ("NPC",         0x50,  0x3E, "Kakariko Village",       None),
    "Man on Roof":                                     ("NPC",         0x52,  0x3E, "Kakariko Village",       None),
    "Frog Ocarina Game":                               ("NPC",         0x54,  0x76, "Zora's River",           None),
    "Frogs in the Rain":                               ("NPC",         0x54,  0x3E, "Zora's River",           None),
    "Horseback Archery 1000 Points":                   ("NPC",         0x5D,  0x3E, "Gerudo's Fortress",      None),
    "Horseback Archery 1500 Points":                   ("NPC",         0x5D,  0x30, "Gerudo's Fortress",      None),
    "Child Shooting Gallery":                          ("NPC",         0x42,  0x60, "the Market",             None),
    "Adult Shooting Gallery":                          ("NPC",         0x42,  0x30, "Kakariko Village",       None),
    "Target in Woods":                                 ("NPC",         0x5B,  0x60, "the Lost Woods",         None),
    "Deku Theater Skull Mask":                         ("NPC",         0x3E,  0x77, "the Lost Woods",         None),
    "Deku Theater Mask of Truth":                      ("NPC",         0x3E,  0x7A, "the Lost Woods",         None),
    "Anju as Adult":                                   ("NPC",         0x52,  0x1D, "Kakariko Village",       None),
    "Biggoron":                                        ("NPC",         0x60,  0x57, "Death Mountain Trail",   None),
    "Anjus Chickens":                                  ("NPC",         0x52,  0x0F, "Kakariko Village",       None),
    "Talons Chickens":                                 ("NPC",         0x4C,  0x14, "Lon Lon Ranch",          None),
    "10 Big Poes":                                     ("NPC",         0x4D,  0x0F, "the Market",             None),
    "Rolling Goron as Child":                          ("NPC",         0x62,  0x34, "Goron City",             None),
    "Underwater Bottle":                               ("NPC",         0x57,  0x15, "Lake Hylia",             None),
    "Lake Hylia Sun":                                  ("NPC",         0x57,  0x58, "Lake Hylia",             None),
    "Gerudo Fortress Membership Card":                 ("NPC",         0x0C,  0x3A, "Gerudo's Fortress",      None),
    "Ocarina of Time":                                 ("NPC",         0x51,  0x0C, "Hyrule Field",           None),

    "Impa House Freestanding PoH":                     ("Collectable", 0x37,  0x01, "Kakariko Village",       None),
    "Tektite Grotto Freestanding PoH":                 ("Collectable", 0x3E,  0x01, "Hyrule Field",           None),
    "Windmill Freestanding PoH":                       ("Collectable", 0x48,  0x01, "Kakariko Village",       None),
    "Dampe Race Freestanding PoH":                     ("Collectable", 0x48,  0x07, "the Graveyard",          None),
    "Lon Lon Tower Freestanding PoH":                  ("Collectable", 0x4C,  0x01, "Lon Lon Ranch",          None),
    "Graveyard Freestanding PoH":                      ("Collectable", 0x53,  0x04, "the Graveyard",          None),
    "Gravedigging Tour":                               ("Collectable", 0x53,  0x08, "the Graveyard",          None),
    "Zora River Lower Freestanding PoH":               ("Collectable", 0x54,  0x04, "Zora's River",           None),
    "Zora River Upper Freestanding PoH":               ("Collectable", 0x54,  0x0B, "Zora's River",           None),
    "Lake Hylia Freestanding PoH":                     ("Collectable", 0x57,  0x1E, "Lake Hylia",             None),
    "Zoras Fountain Iceberg Freestanding PoH":         ("Collectable", 0x59,  0x01, "Zora's Fountain",        None),
    "Zoras Fountain Bottom Freestanding PoH":          ("Collectable", 0x59,  0x14, "Zora's Fountain",        None),
    "Gerudo Valley Waterfall Freestanding PoH":        ("Collectable", 0x5A,  0x01, "Gerudo Valley",          None),
    "Gerudo Valley Crate Freestanding PoH":            ("Collectable", 0x5A,  0x02, "Gerudo Valley",          None),
    "Colossus Freestanding PoH":                       ("Collectable", 0x5C,  0x0D, "Desert Colossus",        None),
    "DM Trail Freestanding PoH":                       ("Collectable", 0x60,  0x1E, "Death Mountain Trail",   None),
    "DM Crater Wall Freestanding PoH":                 ("Collectable", 0x61,  0x02, "Death Mountain Crater",  None),
    "DM Crater Volcano Freestanding PoH":              ("Collectable", 0x61,  0x08, "Death Mountain Crater",  None),
    "Goron City Pot Freestanding PoH":                 ("Collectable", 0x62,  0x1F, "Goron City",             None),
    "Gerudo Fortress North F1 Carpenter":              ("Collectable", 0x0C,  0x0C, "Gerudo's Fortress",      None),
    "Gerudo Fortress North F2 Carpenter":              ("Collectable", 0x0C,  0x0A, "Gerudo's Fortress",      None),
    "Gerudo Fortress South F1 Carpenter":              ("Collectable", 0x0C,  0x0E, "Gerudo's Fortress",      None),
    "Gerudo Fortress South F2 Carpenter":              ("Collectable", 0x0C,  0x0F, "Gerudo's Fortress",      None),

    "Magic Bean Salesman":                             ("Event",       None,  None, "Zora's River",           None),
    "King Zora Moves":                                 ("Event",       None,  None, "Zora's Domain",          None),
    "Master Sword Pedestal":                           ("Event",       None,  None, "Temple of Time",         None),
    "Epona":                                           ("Event",       None,  None, "Lon Lon Ranch",          None),
    "Deku Baba Sticks":                                ("Event",       None,  None, "Kokiri Forest",          None),
    "Deku Baba Nuts":                                  ("Event",       None,  None, "Kokiri Forest",          None),
    "Goron City Stick Pot":                            ("Event",       None,  None, "Goron City",             None),
    "Bottom of the Well Stick Pot":                    ("Event",       None,  None, "Bottom of the Well",     None),
    "Zoras Domain Stick Pot":                          ("Event",       None,  None, "Zora's Domain",          None),
    "Zoras Domain Nut Pot":                            ("Event",       None,  None, "Zora's Domain",          None),
    "Spirit Temple Nut Crate":                         ("Event",       None,  None, "Spirit Temple",          None),
    "Gerudo Fortress Carpenter Rescue":                ("Event",       None,  None, "Gerudo's Fortress",      None),
    "Haunted Wasteland Bombchu Salesman":              ("Event",       None,  None, "Haunted Wasteland",      None),
    "Ganons Castle Forest Trial Clear":                ("Event",       None,  None, "Ganon's Castle",         None),
    "Ganons Castle Fire Trial Clear":                  ("Event",       None,  None, "Ganon's Castle",         None),
    "Ganons Castle Water Trial Clear":                 ("Event",       None,  None, "Ganon's Castle",         None),
    "Ganons Castle Shadow Trial Clear":                ("Event",       None,  None, "Ganon's Castle",         None),
    "Ganons Castle Spirit Trial Clear":                ("Event",       None,  None, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Clear":                 ("Event",       None,  None, "Ganon's Castle",         None),

    # Deku Tree vanilla
    "Deku Tree Lobby Chest":                           ("Chest",       0x00,  0x03, "Deku Tree",              None),
    "Deku Tree Slingshot Chest":                       ("Chest",       0x00,  0x01, "Deku Tree",              None),
    "Deku Tree Slingshot Room Side Chest":             ("Chest",       0x00,  0x05, "Deku Tree",              None),
    "Deku Tree Compass Chest":                         ("Chest",       0x00,  0x02, "Deku Tree",              None),
    "Deku Tree Compass Room Side Chest":               ("Chest",       0x00,  0x06, "Deku Tree",              None),
    "Deku Tree Basement Chest":                        ("Chest",       0x00,  0x04, "Deku Tree",              None),
    # Deku Tree MQ
    "Deku Tree MQ Lobby Chest":                        ("Chest",       0x00,  0x03, "Deku Tree",              None),
    "Deku Tree MQ Compass Chest":                      ("Chest",       0x00,  0x01, "Deku Tree",              None),
    "Deku Tree MQ Slingshot Chest":                    ("Chest",       0x00,  0x06, "Deku Tree",              None),
    "Deku Tree MQ Slingshot Room Back Chest":          ("Chest",       0x00,  0x02, "Deku Tree",              None),
    "Deku Tree MQ Basement Chest":                     ("Chest",       0x00,  0x04, "Deku Tree",              None),
    "Deku Tree MQ Before Spinning Log Chest":          ("Chest",       0x00,  0x05, "Deku Tree",              None),
    "Deku Tree MQ After Spinning Log Chest":           ("Chest",       0x00,  0x00, "Deku Tree",              None),

    # Dodongo's Cavern shared
    "Chest Above King Dodongo":                        ("Chest",       0x12,  0x00, "Dodongo's Cavern",       None),
    # Dodongo's Cavern vanilla
    "Dodongos Cavern Map Chest":                       ("Chest",       0x01,  0x08, "Dodongo's Cavern",       None),
    "Dodongos Cavern Compass Chest":                   ("Chest",       0x01,  0x05, "Dodongo's Cavern",       None),
    "Dodongos Cavern Bomb Flower Platform":            ("Chest",       0x01,  0x06, "Dodongo's Cavern",       None),
    "Dodongos Cavern Bomb Bag Chest":                  ("Chest",       0x01,  0x04, "Dodongo's Cavern",       None),
    "Dodongos Cavern End of Bridge Chest":             ("Chest",       0x01,  0x0A, "Dodongo's Cavern",       None),
    # Dodongo's Cavern MQ
    "Dodongos Cavern MQ Map Chest":                    ("Chest",       0x01,  0x00, "Dodongo's Cavern",       None),
    "Dodongos Cavern MQ Bomb Bag Chest":               ("Chest",       0x01,  0x04, "Dodongo's Cavern",       None),
    "Dodongos Cavern MQ Compass Chest":                ("Chest",       0x01,  0x05, "Dodongo's Cavern",       None),
    "Dodongos Cavern MQ Larva Room Chest":             ("Chest",       0x01,  0x02, "Dodongo's Cavern",       None),
    "Dodongos Cavern MQ Torch Puzzle Room Chest":      ("Chest",       0x01,  0x03, "Dodongo's Cavern",       None),
    "Dodongos Cavern MQ Under Grave Chest":            ("Chest",       0x01,  0x01, "Dodongo's Cavern",       None),

    # Jabu Jabu's Belly vanilla
    "Boomerang Chest":                                 ("Chest",       0x02,  0x01, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly Map Chest":                      ("Chest",       0x02,  0x02, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly Compass Chest":                  ("Chest",       0x02,  0x04, "Jabu Jabu's Belly",      None),
    # Jabu Jabu's Belly MQ
    "Jabu Jabus Belly MQ Entry Side Chest":            ("Chest",       0x02,  0x05, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Map Chest":                   ("Chest",       0x02,  0x03, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Second Room Lower Chest":     ("Chest",       0x02,  0x02, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Compass Chest":               ("Chest",       0x02,  0x00, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Second Room Upper Chest":     ("Chest",       0x02,  0x07, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Basement North Chest":        ("Chest",       0x02,  0x08, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Basement South Chest":        ("Chest",       0x02,  0x04, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Near Boss Chest":             ("Chest",       0x02,  0x0A, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Falling Like Like Room Chest":("Chest",       0x02,  0x09, "Jabu Jabu's Belly",      None),
    "Jabu Jabus Belly MQ Boomerang Room Small Chest":  ("Chest",       0x02,  0x01, "Jabu Jabu's Belly",      None),
    "MQ Boomerang Chest":                              ("Chest",       0x02,  0x06, "Jabu Jabu's Belly",      None),

    # Forest Temple vanilla
    "Forest Temple First Chest":                       ("Chest",       0x03,  0x03, "Forest Temple",          None),
    "Forest Temple Chest Behind Lobby":                ("Chest",       0x03,  0x00, "Forest Temple",          None),
    "Forest Temple Well Chest":                        ("Chest",       0x03,  0x09, "Forest Temple",          None),
    "Forest Temple Map Chest":                         ("Chest",       0x03,  0x01, "Forest Temple",          None),
    "Forest Temple Outside Hookshot Chest":            ("Chest",       0x03,  0x05, "Forest Temple",          None),
    "Forest Temple Falling Room Chest":                ("Chest",       0x03,  0x07, "Forest Temple",          None),
    "Forest Temple Block Push Chest":                  ("Chest",       0x03,  0x04, "Forest Temple",          None),
    "Forest Temple Boss Key Chest":                    ("Chest",       0x03,  0x0E, "Forest Temple",          None),
    "Forest Temple Floormaster Chest":                 ("Chest",       0x03,  0x02, "Forest Temple",          None),
    "Forest Temple Bow Chest":                         ("Chest",       0x03,  0x0C, "Forest Temple",          None),
    "Forest Temple Red Poe Chest":                     ("Chest",       0x03,  0x0D, "Forest Temple",          None),
    "Forest Temple Blue Poe Chest":                    ("Chest",       0x03,  0x0F, "Forest Temple",          None),
    "Forest Temple Near Boss Chest":                   ("Chest",       0x03,  0x0B, "Forest Temple",          None),
    # Forest Temple MQ
    "Forest Temple MQ First Chest":                    ("Chest",       0x03,  0x03, "Forest Temple",          None),
    "Forest Temple MQ Chest Behind Lobby":             ("Chest",       0x03,  0x00, "Forest Temple",          None),
    "Forest Temple MQ Bow Chest":                      ("Chest",       0x03,  0x0C, "Forest Temple",          None),
    "Forest Temple MQ NE Outdoors Lower Chest":        ("Chest",       0x03,  0x01, "Forest Temple",          None),
    "Forest Temple MQ NE Outdoors Upper Chest":        ("Chest",       0x03,  0x05, "Forest Temple",          None),
    "Forest Temple MQ Well Chest":                     ("Chest",       0x03,  0x09, "Forest Temple",          None),
    "Forest Temple MQ Map Chest":                      ("Chest",       0x03,  0x0D, "Forest Temple",          None),
    "Forest Temple MQ Compass Chest":                  ("Chest",       0x03,  0x0F, "Forest Temple",          None),
    "Forest Temple MQ Falling Room Chest":             ("Chest",       0x03,  0x06, "Forest Temple",          None),
    "Forest Temple MQ Near Boss Chest":                ("Chest",       0x03,  0x0B, "Forest Temple",          None),
    "Forest Temple MQ Redead Chest":                   ("Chest",       0x03,  0x02, "Forest Temple",          None),
    "Forest Temple MQ Boss Key Chest":                 ("Chest",       0x03,  0x0E, "Forest Temple",          None),

    # Fire Temple vanilla
    "Fire Temple Chest Near Boss":                     ("Chest",       0x04,  0x01, "Fire Temple",            None),
    "Fire Temple Fire Dancer Chest":                   ("Chest",       0x04,  0x00, "Fire Temple",            None),
    "Fire Temple Boss Key Chest":                      ("Chest",       0x04,  0x0C, "Fire Temple",            None),
    "Fire Temple Big Lava Room Bombable Chest":        ("Chest",       0x04,  0x02, "Fire Temple",            None),
    "Fire Temple Big Lava Room Open Chest":            ("Chest",       0x04,  0x04, "Fire Temple",            None),
    "Fire Temple Boulder Maze Lower Chest":            ("Chest",       0x04,  0x03, "Fire Temple",            None),
    "Fire Temple Boulder Maze Upper Chest":            ("Chest",       0x04,  0x06, "Fire Temple",            None),
    "Fire Temple Boulder Maze Side Room":              ("Chest",       0x04,  0x08, "Fire Temple",            None),
    "Fire Temple Boulder Maze Bombable Pit":           ("Chest",       0x04,  0x0B, "Fire Temple",            None),
    "Fire Temple Scarecrow Chest":                     ("Chest",       0x04,  0x0D, "Fire Temple",            None),
    "Fire Temple Map Chest":                           ("Chest",       0x04,  0x0A, "Fire Temple",            None),
    "Fire Temple Compass Chest":                       ("Chest",       0x04,  0x07, "Fire Temple",            None),
    "Fire Temple Highest Goron Chest":                 ("Chest",       0x04,  0x09, "Fire Temple",            None),
    "Fire Temple Megaton Hammer Chest":                ("Chest",       0x04,  0x05, "Fire Temple",            None),
    # Fire Temple MQ
    "Fire Temple MQ Chest Near Boss":                  ("Chest",       0x04,  0x07, "Fire Temple",            None),
    "Fire Temple MQ Megaton Hammer Chest":             ("Chest",       0x04,  0x00, "Fire Temple",            None),
    "Fire Temple MQ Compass Chest":                    ("Chest",       0x04,  0x0B, "Fire Temple",            None),
    "Fire Temple MQ Maze Lower Chest":                 ("Chest",       0x04,  0x03, "Fire Temple",            None),
    "Fire Temple MQ Maze Upper Chest":                 ("Chest",       0x04,  0x06, "Fire Temple",            None),
    "Fire Temple MQ West Tower Top Chest":             ("Chest",       0x04,  0x05, "Fire Temple",            None),
    "Fire Temple MQ Entrance Hallway Small Chest":     ("Chest",       0x04,  0x02, "Fire Temple",            None),
    "Fire Temple MQ Map Chest":                        ("Chest",       0x04,  0x0C, "Fire Temple",            None),
    "Fire Temple MQ Boss Key Chest":                   ("Chest",       0x04,  0x04, "Fire Temple",            None),
    "Fire Temple MQ Big Lava Room Bombable Chest":     ("Chest",       0x04,  0x01, "Fire Temple",            None),
    "Fire Temple MQ Maze Side Room":                   ("Chest",       0x04,  0x08, "Fire Temple",            None),
    "Fire Temple MQ Freestanding Key":                 ("Collectable", 0x04,  0x1C, "Fire Temple",            None),

    # Water Temple vanilla
    "Water Temple Map Chest":                          ("Chest",       0x05,  0x02, "Water Temple",           None),
    "Water Temple Compass Chest":                      ("Chest",       0x05,  0x09, "Water Temple",           None),
    "Water Temple Torches Chest":                      ("Chest",       0x05,  0x01, "Water Temple",           None),
    "Water Temple Dragon Chest":                       ("Chest",       0x05,  0x0A, "Water Temple",           None),
    "Water Temple Central Bow Target Chest":           ("Chest",       0x05,  0x08, "Water Temple",           None),
    "Water Temple Central Pillar Chest":               ("Chest",       0x05,  0x06, "Water Temple",           None),
    "Water Temple Cracked Wall Chest":                 ("Chest",       0x05,  0x00, "Water Temple",           None),
    "Water Temple Boss Key Chest":                     ("Chest",       0x05,  0x05, "Water Temple",           None),
    "Water Temple Dark Link Chest":                    ("Chest",       0x05,  0x07, "Water Temple",           None),
    "Water Temple River Chest":                        ("Chest",       0x05,  0x03, "Water Temple",           None),
    # Water Temple MQ
    "Water Temple MQ Central Pillar Chest":            ("Chest",       0x05,  0x06, "Water Temple",           None),
    "Water Temple MQ Boss Key Chest":                  ("Chest",       0x05,  0x05, "Water Temple",           None),
    "Water Temple MQ Longshot Chest":                  ("Chest",       0x05,  0x00, "Water Temple",           None),
    "Water Temple MQ Compass Chest":                   ("Chest",       0x05,  0x01, "Water Temple",           None),
    "Water Temple MQ Map Chest":                       ("Chest",       0x05,  0x02, "Water Temple",           None),
    "Water Temple MQ Freestanding Key":                ("Collectable", 0x05,  0x01, "Water Temple",           None),

    # Spirit Temple vanilla
    "Spirit Temple Child Left Chest":                  ("Chest",       0x06,  0x08, "Spirit Temple",          None),
    "Spirit Temple Child Right Chest":                 ("Chest",       0x06,  0x00, "Spirit Temple",          None),
    "Spirit Temple Compass Chest":                     ("Chest",       0x06,  0x04, "Spirit Temple",          None),
    "Spirit Temple Early Adult Right Chest":           ("Chest",       0x06,  0x07, "Spirit Temple",          None),
    "Spirit Temple First Mirror Right Chest":          ("Chest",       0x06,  0x0D, "Spirit Temple",          None),
    "Spirit Temple First Mirror Left Chest":           ("Chest",       0x06,  0x0E, "Spirit Temple",          None),
    "Spirit Temple Map Chest":                         ("Chest",       0x06,  0x03, "Spirit Temple",          None),
    "Spirit Temple Child Climb East Chest":            ("Chest",       0x06,  0x06, "Spirit Temple",          None),
    "Spirit Temple Child Climb North Chest":           ("Chest",       0x06,  0x0C, "Spirit Temple",          None),
    "Spirit Temple Sun Block Room Chest":              ("Chest",       0x06,  0x01, "Spirit Temple",          None),
    "Spirit Temple Statue Hand Chest":                 ("Chest",       0x06,  0x02, "Spirit Temple",          None),
    "Spirit Temple NE Main Room Chest":                ("Chest",       0x06,  0x0F, "Spirit Temple",          None),
    "Spirit Temple Near Four Armos Chest":             ("Chest",       0x06,  0x05, "Spirit Temple",          None),
    "Spirit Temple Hallway Left Invisible Chest":      ("Chest",       0x06,  0x14, "Spirit Temple",          None),
    "Spirit Temple Hallway Right Invisible Chest":     ("Chest",       0x06,  0x15, "Spirit Temple",          None),
    "Spirit Temple Boss Key Chest":                    ("Chest",       0x06,  0x0A, "Spirit Temple",          None),
    "Spirit Temple Topmost Chest":                     ("Chest",       0x06,  0x12, "Spirit Temple",          None),
    # Spirit Temple MQ
    "Spirit Temple MQ Entrance Front Left Chest":      ("Chest",       0x06,  0x1A, "Spirit Temple",          None),
    "Spirit Temple MQ Entrance Back Right Chest":      ("Chest",       0x06,  0x1F, "Spirit Temple",          None),
    "Spirit Temple MQ Entrance Front Right Chest":     ("Chest",       0x06,  0x1B, "Spirit Temple",          None),
    "Spirit Temple MQ Entrance Back Left Chest":       ("Chest",       0x06,  0x1E, "Spirit Temple",          None),
    "Spirit Temple MQ Child Center Chest":             ("Chest",       0x06,  0x1D, "Spirit Temple",          None),
    "Spirit Temple MQ Map Chest":                      ("Chest",       0x06,  0x00, "Spirit Temple",          None),
    "Spirit Temple MQ Child Left Chest":               ("Chest",       0x06,  0x08, "Spirit Temple",          None),
    "Spirit Temple MQ Child Climb North Chest":        ("Chest",       0x06,  0x06, "Spirit Temple",          None),
    "Spirit Temple MQ Child Climb South Chest":        ("Chest",       0x06,  0x0C, "Spirit Temple",          None),
    "Spirit Temple MQ Compass Chest":                  ("Chest",       0x06,  0x03, "Spirit Temple",          None),
    "Spirit Temple MQ Lower NE Main Room Chest":       ("Chest",       0x06,  0x0F, "Spirit Temple",          None),
    "Spirit Temple MQ Upper NE Main Room Chest":       ("Chest",       0x06,  0x02, "Spirit Temple",          None),
    "Spirit Temple MQ Silver Block Hallway Chest":     ("Chest",       0x06,  0x1C, "Spirit Temple",          None),
    "Spirit Temple MQ Sun Block Room Chest":           ("Chest",       0x06,  0x01, "Spirit Temple",          None),
    "Spirit Temple MQ Lower Adult Right Chest":        ("Chest",       0x06,  0x07, "Spirit Temple",          None),
    "Spirit Temple MQ Lower Adult Left Chest":         ("Chest",       0x06,  0x04, "Spirit Temple",          None),
    "Spirit Temple MQ Beamos Room Chest":              ("Chest",       0x06,  0x19, "Spirit Temple",          None),
    "Spirit Temple MQ Ice Trap Chest":                 ("Chest",       0x06,  0x18, "Spirit Temple",          None),
    "Spirit Temple MQ Boss Key Chest":                 ("Chest",       0x06,  0x05, "Spirit Temple",          None),
    "Spirit Temple MQ Mirror Puzzle Invisible Chest":  ("Chest",       0x06,  0x12, "Spirit Temple",          None),

    # Shadow Temple vanilla
    "Shadow Temple Map Chest":                         ("Chest",       0x07,  0x01, "Shadow Temple",          None),
    "Shadow Temple Hover Boots Chest":                 ("Chest",       0x07,  0x07, "Shadow Temple",          None),
    "Shadow Temple Compass Chest":                     ("Chest",       0x07,  0x03, "Shadow Temple",          None),
    "Shadow Temple Early Silver Rupee Chest":          ("Chest",       0x07,  0x02, "Shadow Temple",          None),
    "Shadow Temple Invisible Blades Visible Chest":    ("Chest",       0x07,  0x0C, "Shadow Temple",          None),
    "Shadow Temple Invisible Blades Invisible Chest":  ("Chest",       0x07,  0x16, "Shadow Temple",          None),
    "Shadow Temple Falling Spikes Lower Chest":        ("Chest",       0x07,  0x05, "Shadow Temple",          None),
    "Shadow Temple Falling Spikes Upper Chest":        ("Chest",       0x07,  0x06, "Shadow Temple",          None),
    "Shadow Temple Falling Spikes Switch Chest":       ("Chest",       0x07,  0x04, "Shadow Temple",          None),
    "Shadow Temple Invisible Spikes Chest":            ("Chest",       0x07,  0x09, "Shadow Temple",          None),
    "Shadow Temple Wind Hint Chest":                   ("Chest",       0x07,  0x15, "Shadow Temple",          None),
    "Shadow Temple After Wind Enemy Chest":            ("Chest",       0x07,  0x08, "Shadow Temple",          None),
    "Shadow Temple After Wind Hidden Chest":           ("Chest",       0x07,  0x14, "Shadow Temple",          None),
    "Shadow Temple Spike Walls Left Chest":            ("Chest",       0x07,  0x0A, "Shadow Temple",          None),
    "Shadow Temple Boss Key Chest":                    ("Chest",       0x07,  0x0B, "Shadow Temple",          None),
    "Shadow Temple Hidden Floormaster Chest":          ("Chest",       0x07,  0x0D, "Shadow Temple",          None),
    "Shadow Temple Freestanding Key":                  ("Collectable", 0x07,  0x01, "Shadow Temple",          None),
    # Shadow Temple MQ
    "Shadow Temple MQ Compass Chest":                  ("Chest",       0x07,  0x01, "Shadow Temple",          None),
    "Shadow Temple MQ Hover Boots Chest":              ("Chest",       0x07,  0x07, "Shadow Temple",          None),
    "Shadow Temple MQ Early Gibdos Chest":             ("Chest",       0x07,  0x02, "Shadow Temple",          None),
    "Shadow Temple MQ Map Chest":                      ("Chest",       0x07,  0x03, "Shadow Temple",          None),
    "Shadow Temple MQ Beamos Silver Rupees Chest":     ("Chest",       0x07,  0x0F, "Shadow Temple",          None),
    "Shadow Temple MQ Falling Spikes Switch Chest":    ("Chest",       0x07,  0x04, "Shadow Temple",          None),
    "Shadow Temple MQ Falling Spikes Lower Chest":     ("Chest",       0x07,  0x05, "Shadow Temple",          None),
    "Shadow Temple MQ Falling Spikes Upper Chest":     ("Chest",       0x07,  0x06, "Shadow Temple",          None),
    "Shadow Temple MQ Invisible Spikes Chest":         ("Chest",       0x07,  0x09, "Shadow Temple",          None),
    "Shadow Temple MQ Boss Key Chest":                 ("Chest",       0x07,  0x0B, "Shadow Temple",          None),
    "Shadow Temple MQ Spike Walls Left Chest":         ("Chest",       0x07,  0x0A, "Shadow Temple",          None),
    "Shadow Temple MQ Stalfos Room Chest":             ("Chest",       0x07,  0x10, "Shadow Temple",          None),
    "Shadow Temple MQ Invisible Blades Invisible Chest": ("Chest",     0x07,  0x16, "Shadow Temple",          None),
    "Shadow Temple MQ Invisible Blades Visible Chest": ("Chest",       0x07,  0x0C, "Shadow Temple",          None),
    "Shadow Temple MQ Bomb Flower Chest":              ("Chest",       0x07,  0x0D, "Shadow Temple",          None),
    "Shadow Temple MQ Wind Hint Chest":                ("Chest",       0x07,  0x15, "Shadow Temple",          None),
    "Shadow Temple MQ After Wind Hidden Chest":        ("Chest",       0x07,  0x14, "Shadow Temple",          None),
    "Shadow Temple MQ After Wind Enemy Chest":         ("Chest",       0x07,  0x08, "Shadow Temple",          None),
    "Shadow Temple MQ Near Ship Invisible Chest":      ("Chest",       0x07,  0x0E, "Shadow Temple",          None),
    "Shadow Temple MQ Freestanding Key":               ("Collectable", 0x07,  0x06, "Shadow Temple",          None),

    # Bottom of the Well vanilla
    "Bottom of the Well Front Left Hidden Wall":       ("Chest",       0x08,  0x08, "Bottom of the Well",     None),
    "Bottom of the Well Front Center Bombable":        ("Chest",       0x08,  0x02, "Bottom of the Well",     None),
    "Bottom of the Well Right Bottom Hidden Wall":     ("Chest",       0x08,  0x05, "Bottom of the Well",     None),
    "Bottom of the Well Center Large Chest":           ("Chest",       0x08,  0x01, "Bottom of the Well",     None),
    "Bottom of the Well Center Small Chest":           ("Chest",       0x08,  0x0E, "Bottom of the Well",     None),
    "Bottom of the Well Back Left Bombable":           ("Chest",       0x08,  0x04, "Bottom of the Well",     None),
    "Bottom of the Well Defeat Boss":                  ("Chest",       0x08,  0x03, "Bottom of the Well",     None),
    "Bottom of the Well Invisible Chest":              ("Chest",       0x08,  0x14, "Bottom of the Well",     None),
    "Bottom of the Well Underwater Front Chest":       ("Chest",       0x08,  0x10, "Bottom of the Well",     None),
    "Bottom of the Well Underwater Left Chest":        ("Chest",       0x08,  0x09, "Bottom of the Well",     None),
    "Bottom of the Well Basement Chest":               ("Chest",       0x08,  0x07, "Bottom of the Well",     None),
    "Bottom of the Well Locked Pits":                  ("Chest",       0x08,  0x0A, "Bottom of the Well",     None),
    "Bottom of the Well Behind Right Grate":           ("Chest",       0x08,  0x0C, "Bottom of the Well",     None),
    "Bottom of the Well Freestanding Key":             ("Collectable", 0x08,  0x01, "Bottom of the Well",     None),
    # Bottom of the Well MQ
    "Bottom of the Well MQ Map Chest":                 ("Chest",       0x08,  0x03, "Bottom of the Well",     None),
    "Bottom of the Well MQ Lens Chest":                ("Chest",       0x08,  0x01, "Bottom of the Well",     None),
    "Bottom of the Well MQ Compass Chest":             ("Chest",       0x08,  0x02, "Bottom of the Well",     None),
    "Bottom of the Well MQ Dead Hand Freestanding Key":("Collectable", 0x08,  0x02, "Bottom of the Well",     None),
    "Bottom of the Well MQ East Inner Room Freestanding Key":("Collectable",0x08,0x01,"Bottom of the Well",   None),

    # Ice Cavern vanilla
    "Ice Cavern Map Chest":                            ("Chest",       0x09,  0x00, "Ice Cavern",             None),
    "Ice Cavern Compass Chest":                        ("Chest",       0x09,  0x01, "Ice Cavern",             None),
    "Ice Cavern Iron Boots Chest":                     ("Chest",       0x09,  0x02, "Ice Cavern",             None),
    "Ice Cavern Freestanding PoH":                     ("Collectable", 0x09,  0x01, "Ice Cavern",             None),
    # Ice Cavern MQ
    "Ice Cavern MQ Iron Boots Chest":                  ("Chest",       0x09,  0x02, "Ice Cavern",             None),
    "Ice Cavern MQ Compass Chest":                     ("Chest",       0x09,  0x00, "Ice Cavern",             None),
    "Ice Cavern MQ Map Chest":                         ("Chest",       0x09,  0x01, "Ice Cavern",             None),
    "Ice Cavern MQ Freestanding PoH":                  ("Collectable", 0x09,  0x01, "Ice Cavern",             None),

    # Gerudo Training Grounds vanilla
    "Gerudo Training Grounds Lobby Left Chest":        ("Chest",       0x0B,  0x13, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Lobby Right Chest":       ("Chest",       0x0B,  0x07, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Stalfos Chest":           ("Chest",       0x0B,  0x00, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Beamos Chest":            ("Chest",       0x0B,  0x01, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Hidden Ceiling Chest":    ("Chest",       0x0B,  0x0B, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Path First Chest":   ("Chest",       0x0B,  0x06, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Path Second Chest":  ("Chest",       0x0B,  0x0A, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Path Third Chest":   ("Chest",       0x0B,  0x09, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Path Final Chest":   ("Chest",       0x0B,  0x0C, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Right Central Chest":("Chest",       0x0B,  0x05, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Maze Right Side Chest":   ("Chest",       0x0B,  0x08, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Underwater Silver Rupee Chest": ("Chest", 0x0B,  0x0D, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Hammer Room Clear Chest": ("Chest",       0x0B,  0x12, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Hammer Room Switch Chest":("Chest",       0x0B,  0x10, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Eye Statue Chest":        ("Chest",       0x0B,  0x03, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Near Scarecrow Chest":    ("Chest",       0x0B,  0x04, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Before Heavy Block Chest":("Chest",       0x0B,  0x11, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Heavy Block First Chest": ("Chest",       0x0B,  0x0F, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Heavy Block Second Chest":("Chest",       0x0B,  0x0E, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Heavy Block Third Chest": ("Chest",       0x0B,  0x14, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Heavy Block Fourth Chest":("Chest",       0x0B,  0x02, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds Freestanding Key":        ("Collectable", 0x0B,  0x01, "Gerudo Training Grounds", None),
    # Gerudo Training Grounds MQ
    "Gerudo Training Grounds MQ Lobby Right Chest":    ("Chest",       0x0B,  0x07, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Lobby Left Chest":     ("Chest",       0x0B,  0x13, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ First Iron Knuckle Chest": ("Chest",   0x0B,  0x00, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Before Heavy Block Chest": ("Chest",   0x0B,  0x11, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Eye Statue Chest":     ("Chest",       0x0B,  0x03, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Flame Circle Chest":   ("Chest",       0x0B,  0x0E, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Second Iron Knuckle Chest": ("Chest",  0x0B,  0x12, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Dinolfos Chest":       ("Chest",       0x0B,  0x01, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Ice Arrows Chest":     ("Chest",       0x0B,  0x04, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Maze Right Central Chest": ("Chest",   0x0B,  0x05, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Maze Path First Chest":("Chest",       0x0B,  0x06, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Maze Right Side Chest":("Chest",       0x0B,  0x08, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Maze Path Third Chest":("Chest",       0x0B,  0x09, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Maze Path Second Chest": ("Chest",     0x0B,  0x0A, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Hidden Ceiling Chest": ("Chest",       0x0B,  0x0B, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Underwater Silver Rupee Chest":("Chest",0x0B, 0x0D, "Gerudo Training Grounds", None),
    "Gerudo Training Grounds MQ Heavy Block Chest":    ("Chest",       0x0B,  0x02, "Gerudo Training Grounds", None),

    # Ganon's Castle shared
    "Ganons Tower Boss Key Chest":                     ("Chest",       0x0A,  0x0B, "Ganon's Castle",         None),
    # Ganon's Castle vanilla
    "Ganons Castle Forest Trial Chest":                ("Chest",       0x0D,  0x09, "Ganon's Castle",         None),
    "Ganons Castle Water Trial Left Chest":            ("Chest",       0x0D,  0x07, "Ganon's Castle",         None),
    "Ganons Castle Water Trial Right Chest":           ("Chest",       0x0D,  0x06, "Ganon's Castle",         None),
    "Ganons Castle Shadow Trial First Chest":          ("Chest",       0x0D,  0x08, "Ganon's Castle",         None),
    "Ganons Castle Shadow Trial Second Chest":         ("Chest",       0x0D,  0x05, "Ganon's Castle",         None),
    "Ganons Castle Spirit Trial First Chest":          ("Chest",       0x0D,  0x12, "Ganon's Castle",         None),
    "Ganons Castle Spirit Trial Second Chest":         ("Chest",       0x0D,  0x14, "Ganon's Castle",         None),
    "Ganons Castle Light Trial First Left Chest":      ("Chest",       0x0D,  0x0C, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Second Left Chest":     ("Chest",       0x0D,  0x0B, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Third Left Chest":      ("Chest",       0x0D,  0x0D, "Ganon's Castle",         None),
    "Ganons Castle Light Trial First Right Chest":     ("Chest",       0x0D,  0x0E, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Second Right Chest":    ("Chest",       0x0D,  0x0A, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Third Right Chest":     ("Chest",       0x0D,  0x0F, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Invisible Enemies Chest": ("Chest",     0x0D,  0x10, "Ganon's Castle",         None),
    "Ganons Castle Light Trial Lullaby Chest":         ("Chest",       0x0D,  0x11, "Ganon's Castle",         None),
    # Ganon's Castle MQ
    "Ganons Castle MQ Water Trial Chest":              ("Chest",       0x0D,  0x01, "Ganon's Castle",         None),
    "Ganons Castle MQ Forest Trial First Chest":       ("Chest",       0x0D,  0x02, "Ganon's Castle",         None),
    "Ganons Castle MQ Forest Trial Second Chest":      ("Chest",       0x0D,  0x03, "Ganon's Castle",         None),
    "Ganons Castle MQ Light Trial Lullaby Chest":      ("Chest",       0x0D,  0x04, "Ganon's Castle",         None),
    "Ganons Castle MQ Shadow Trial First Chest":       ("Chest",       0x0D,  0x00, "Ganon's Castle",         None),
    "Ganons Castle MQ Shadow Trial Second Chest":      ("Chest",       0x0D,  0x05, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial Golden Gauntlets Chest": ("Chest",  0x0D,  0x06, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial Sun Back Right Chest": ("Chest",    0x0D,  0x07, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial Sun Back Left Chest": ("Chest",     0x0D,  0x08, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial Sun Front Left Chest": ("Chest",    0x0D,  0x09, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial First Chest":       ("Chest",       0x0D,  0x0A, "Ganon's Castle",         None),
    "Ganons Castle MQ Spirit Trial Second Chest":      ("Chest",       0x0D,  0x14, "Ganon's Castle",         None),
    "Ganons Castle MQ Forest Trial Freestanding Key":  ("Collectable", 0x0D,  0x01, "Ganon's Castle",         None),

    "Links Pocket":                                    ("Boss",        None,  None, "Link's Pocket",          None),
    "Queen Gohma":                                     ("Boss",        None,  0x6C, "Deku Tree",              (0x0CA315F, 0x2079571)),
    "King Dodongo":                                    ("Boss",        None,  0x6D, "Dodongo's Cavern",       (0x0CA30DF, 0x2223309)),
    "Barinade":                                        ("Boss",        None,  0x6E, "Jabu Jabu's Belly",      (0x0CA36EB, 0x2113C19)),
    "Phantom Ganon":                                   ("Boss",        None,  0x66, "Forest Temple",          (0x0CA3D07, 0x0D4ED79)),
    "Volvagia":                                        ("Boss",        None,  0x67, "Fire Temple",            (0x0CA3D93, 0x0D10135)),
    "Morpha":                                          ("Boss",        None,  0x68, "Water Temple",           (0x0CA3E1F, 0x0D5A3A9)),
    "Twinrova":                                        ("Boss",        None,  0x69, "Spirit Temple",          (0x0CA3EB3, 0x0D39FF1)),
    "Bongo Bongo":                                     ("Boss",        None,  0x6A, "Shadow Temple",          (0x0CA3F43, 0x0D13E19)),
    "Ganon":                                           ("Event",       None,  None, "Ganon's Castle",         None),

    "Queen Gohma Heart":                               ("BossHeart",   0x11,  0x4F, "Deku Tree",              None),
    "King Dodongo Heart":                              ("BossHeart",   0x12,  0x4F, "Dodongo's Cavern",       None),
    "Barinade Heart":                                  ("BossHeart",   0x13,  0x4F, "Jabu Jabu's Belly",      None),
    "Phantom Ganon Heart":                             ("BossHeart",   0x14,  0x4F, "Forest Temple",          None),
    "Volvagia Heart":                                  ("BossHeart",   0x15,  0x4F, "Fire Temple",            None),
    "Morpha Heart":                                    ("BossHeart",   0x16,  0x4F, "Water Temple",           None),
    "Twinrova Heart":                                  ("BossHeart",   0x17,  0x4F, "Spirit Temple",          None),
    "Bongo Bongo Heart":                               ("BossHeart",   0x18,  0x4F, "Shadow Temple",          None),

    # note that the scene for skulltulas is not the actual scene the token appears in
    # rather, it is the index of the grouping used when storing skulltula collection
    # for example, zora river, zora's domain, and zora fountain are all a single 'scene' for skulltulas
    "GS Deku Tree Basement Back Room":                 ("GS Token",    0x00,  0x01, "Deku Tree",              None),
    "GS Deku Tree Basement Gate":                      ("GS Token",    0x00,  0x02, "Deku Tree",              None),
    "GS Deku Tree Basement Vines":                     ("GS Token",    0x00,  0x04, "Deku Tree",              None),
    "GS Deku Tree Compass Room":                       ("GS Token",    0x00,  0x08, "Deku Tree",              None),
    "GS Deku Tree MQ Lobby":                           ("GS Token",    0x00,  0x02, "Deku Tree",              None),
    "GS Deku Tree MQ Compass Room":                    ("GS Token",    0x00,  0x08, "Deku Tree",              None),
    "GS Deku Tree MQ Basement Ceiling":                ("GS Token",    0x00,  0x04, "Deku Tree",              None),
    "GS Deku Tree MQ Basement Back Room":              ("GS Token",    0x00,  0x01, "Deku Tree",              None),
    "GS Dodongo's Cavern Vines Above Stairs":          ("GS Token",    0x01,  0x01, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern Scarecrow":                   ("GS Token",    0x01,  0x02, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern Alcove Above Stairs":         ("GS Token",    0x01,  0x04, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern Back Room":                   ("GS Token",    0x01,  0x08, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern East Side Room":              ("GS Token",    0x01,  0x10, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern MQ Scrub Room":               ("GS Token",    0x01,  0x02, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern MQ Song of Time Block Room":  ("GS Token",    0x01,  0x08, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern MQ Lizalfos Room":            ("GS Token",    0x01,  0x04, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern MQ Larva Room":               ("GS Token",    0x01,  0x10, "Dodongo's Cavern",       None),
    "GS Dodongo's Cavern MQ Back Area":                ("GS Token",    0x01,  0x01, "Dodongo's Cavern",       None),
    "GS Jabu Jabu Lobby Basement Lower":               ("GS Token",    0x02,  0x01, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu Lobby Basement Upper":               ("GS Token",    0x02,  0x02, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu Near Boss":                          ("GS Token",    0x02,  0x04, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu Water Switch Room":                  ("GS Token",    0x02,  0x08, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu MQ Tailpasaran Room":                ("GS Token",    0x02,  0x04, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu MQ Invisible Enemies Room":          ("GS Token",    0x02,  0x08, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu MQ Boomerang Room":                  ("GS Token",    0x02,  0x01, "Jabu Jabu's Belly",      None),
    "GS Jabu Jabu MQ Near Boss":                       ("GS Token",    0x02,  0x02, "Jabu Jabu's Belly",      None),
    "GS Forest Temple Outdoor East":                   ("GS Token",    0x03,  0x01, "Forest Temple",          None),
    "GS Forest Temple First Room":                     ("GS Token",    0x03,  0x02, "Forest Temple",          None),
    "GS Forest Temple Outdoor West":                   ("GS Token",    0x03,  0x04, "Forest Temple",          None),
    "GS Forest Temple Lobby":                          ("GS Token",    0x03,  0x08, "Forest Temple",          None),
    "GS Forest Temple Basement":                       ("GS Token",    0x03,  0x10, "Forest Temple",          None),
    "GS Forest Temple MQ First Hallway":               ("GS Token",    0x03,  0x02, "Forest Temple",          None),
    "GS Forest Temple MQ Block Push Room":             ("GS Token",    0x03,  0x10, "Forest Temple",          None),
    "GS Forest Temple MQ Outdoor East":                ("GS Token",    0x03,  0x01, "Forest Temple",          None),
    "GS Forest Temple MQ Outdoor West":                ("GS Token",    0x03,  0x04, "Forest Temple",          None),
    "GS Forest Temple MQ Well":                        ("GS Token",    0x03,  0x08, "Forest Temple",          None),
    "GS Fire Temple Song of Time Room":                ("GS Token",    0x04,  0x01, "Fire Temple",            None),
    "GS Fire Temple Basement":                         ("GS Token",    0x04,  0x02, "Fire Temple",            None),
    "GS Fire Temple Unmarked Bomb Wall":               ("GS Token",    0x04,  0x04, "Fire Temple",            None),
    "GS Fire Temple East Tower Top":                   ("GS Token",    0x04,  0x08, "Fire Temple",            None),
    "GS Fire Temple East Tower Climb":                 ("GS Token",    0x04,  0x10, "Fire Temple",            None),
    "GS Fire Temple MQ Above Fire Wall Maze":          ("GS Token",    0x04,  0x02, "Fire Temple",            None),
    "GS Fire Temple MQ Fire Wall Maze Center":         ("GS Token",    0x04,  0x08, "Fire Temple",            None),
    "GS Fire Temple MQ Big Lava Room":                 ("GS Token",    0x04,  0x01, "Fire Temple",            None),
    "GS Fire Temple MQ Fire Wall Maze Side Room":      ("GS Token",    0x04,  0x10, "Fire Temple",            None),
    "GS Fire Temple MQ East Tower Top":                ("GS Token",    0x04,  0x04, "Fire Temple",            None),
    "GS Water Temple South Basement":                  ("GS Token",    0x05,  0x01, "Water Temple",           None),
    "GS Water Temple Falling Platform Room":           ("GS Token",    0x05,  0x02, "Water Temple",           None),
    "GS Water Temple Central Room":                    ("GS Token",    0x05,  0x04, "Water Temple",           None),
    "GS Water Temple Near Boss Key Chest":             ("GS Token",    0x05,  0x08, "Water Temple",           None),
    "GS Water Temple Serpent River":                   ("GS Token",    0x05,  0x10, "Water Temple",           None),
    "GS Water Temple MQ Before Upper Water Switch":    ("GS Token",    0x05,  0x04, "Water Temple",           None),
    "GS Water Temple MQ North Basement":               ("GS Token",    0x05,  0x08, "Water Temple",           None),
    "GS Water Temple MQ Lizalfos Hallway":             ("GS Token",    0x05,  0x01, "Water Temple",           None),
    "GS Water Temple MQ Serpent River":                ("GS Token",    0x05,  0x02, "Water Temple",           None),
    "GS Water Temple MQ South Basement":               ("GS Token",    0x05,  0x10, "Water Temple",           None),
    "GS Spirit Temple Hall to West Iron Knuckle":      ("GS Token",    0x06,  0x01, "Spirit Temple",          None),
    "GS Spirit Temple Boulder Room":                   ("GS Token",    0x06,  0x02, "Spirit Temple",          None),
    "GS Spirit Temple Lobby":                          ("GS Token",    0x06,  0x04, "Spirit Temple",          None),
    "GS Spirit Temple Bomb for Light Room":            ("GS Token",    0x06,  0x08, "Spirit Temple",          None),
    "GS Spirit Temple Metal Fence":                    ("GS Token",    0x06,  0x10, "Spirit Temple",          None),
    "GS Spirit Temple MQ Lower Adult Right":           ("GS Token",    0x06,  0x08, "Spirit Temple",          None),
    "GS Spirit Temple MQ Lower Adult Left":            ("GS Token",    0x06,  0x02, "Spirit Temple",          None),
    "GS Spirit Temple MQ Iron Knuckle West":           ("GS Token",    0x06,  0x04, "Spirit Temple",          None),
    "GS Spirit Temple MQ Iron Knuckle North":          ("GS Token",    0x06,  0x10, "Spirit Temple",          None),
    "GS Spirit Temple MQ Sun Block Room":              ("GS Token",    0x06,  0x01, "Spirit Temple",          None),
    "GS Shadow Temple Single Giant Pot":               ("GS Token",    0x07,  0x01, "Shadow Temple",          None),
    "GS Shadow Temple Crusher Room":                   ("GS Token",    0x07,  0x02, "Shadow Temple",          None),
    "GS Shadow Temple Triple Giant Pot":               ("GS Token",    0x07,  0x04, "Shadow Temple",          None),
    "GS Shadow Temple Like Like Room":                 ("GS Token",    0x07,  0x08, "Shadow Temple",          None),
    "GS Shadow Temple Near Ship":                      ("GS Token",    0x07,  0x10, "Shadow Temple",          None),
    "GS Shadow Temple MQ Crusher Room":                ("GS Token",    0x07,  0x02, "Shadow Temple",          None),
    "GS Shadow Temple MQ Wind Hint Room":              ("GS Token",    0x07,  0x01, "Shadow Temple",          None),
    "GS Shadow Temple MQ After Wind":                  ("GS Token",    0x07,  0x08, "Shadow Temple",          None),
    "GS Shadow Temple MQ After Ship":                  ("GS Token",    0x07,  0x10, "Shadow Temple",          None),
    "GS Shadow Temple MQ Near Boss":                   ("GS Token",    0x07,  0x04, "Shadow Temple",          None),
    "GS Well Like Like Cage":                          ("GS Token",    0x08,  0x01, "Bottom of the Well",     None),
    "GS Well East Inner Room":                         ("GS Token",    0x08,  0x02, "Bottom of the Well",     None),
    "GS Well West Inner Room":                         ("GS Token",    0x08,  0x04, "Bottom of the Well",     None),
    "GS Well MQ Basement":                             ("GS Token",    0x08,  0x01, "Bottom of the Well",     None),
    "GS Well MQ Coffin Room":                          ("GS Token",    0x08,  0x04, "Bottom of the Well",     None),
    "GS Well MQ West Inner Room":                      ("GS Token",    0x08,  0x02, "Bottom of the Well",     None),
    "GS Ice Cavern Push Block Room":                   ("GS Token",    0x09,  0x01, "Ice Cavern",             None),
    "GS Ice Cavern Spinning Scythe Room":              ("GS Token",    0x09,  0x02, "Ice Cavern",             None),
    "GS Ice Cavern Heart Piece Room":                  ("GS Token",    0x09,  0x04, "Ice Cavern",             None),
    "GS Ice Cavern MQ Scarecrow":                      ("GS Token",    0x09,  0x01, "Ice Cavern",             None),
    "GS Ice Cavern MQ Ice Block":                      ("GS Token",    0x09,  0x04, "Ice Cavern",             None),
    "GS Ice Cavern MQ Red Ice":                        ("GS Token",    0x09,  0x02, "Ice Cavern",             None),
    "GS Hyrule Field Near Gerudo Valley":              ("GS Token",    0x0A,  0x01, "Hyrule Field",           None),
    "GS Hyrule Field near Kakariko":                   ("GS Token",    0x0A,  0x02, "Hyrule Field",           None),
    "GS Lon Lon Ranch Back Wall":                      ("GS Token",    0x0B,  0x01, "Lon Lon Ranch",          None),
    "GS Lon Lon Ranch Rain Shed":                      ("GS Token",    0x0B,  0x02, "Lon Lon Ranch",          None),
    "GS Lon Lon Ranch House Window":                   ("GS Token",    0x0B,  0x04, "Lon Lon Ranch",          None),
    "GS Lon Lon Ranch Tree":                           ("GS Token",    0x0B,  0x08, "Lon Lon Ranch",          None),
    "GS Kokiri Bean Patch":                            ("GS Token",    0x0C,  0x01, "Kokiri Forest",          None),
    "GS Kokiri Know It All House":                     ("GS Token",    0x0C,  0x02, "Kokiri Forest",          None),
    "GS Kokiri House of Twins":                        ("GS Token",    0x0C,  0x04, "Kokiri Forest",          None),
    "GS Lost Woods Bean Patch Near Bridge":            ("GS Token",    0x0D,  0x01, "the Lost Woods",         None),
    "GS Lost Woods Bean Patch Near Stage":             ("GS Token",    0x0D,  0x02, "the Lost Woods",         None),
    "GS Lost Woods Above Stage":                       ("GS Token",    0x0D,  0x04, "the Lost Woods",         None),
    "GS Sacred Forest Meadow":                         ("GS Token",    0x0D,  0x08, "Sacred Forest Meadow",   None),
    "GS Outside Ganon's Castle":                       ("GS Token",    0x0E,  0x01, "outside Ganon's Castle", None),
    "GS Hyrule Castle Grotto":                         ("GS Token",    0x0E,  0x02, "Hyrule Castle",          None),
    "GS Hyrule Castle Tree":                           ("GS Token",    0x0E,  0x04, "Hyrule Castle",          None),
    "GS Castle Market Guard House":                    ("GS Token",    0x0E,  0x08, "the Market",             None),
    "GS Mountain Crater Bean Patch":                   ("GS Token",    0x0F,  0x01, "Death Mountain Crater",  None),
    "GS Mountain Trail Bean Patch":                    ("GS Token",    0x0F,  0x02, "Death Mountain Trail",   None),
    "GS Mountain Trail Bomb Alcove":                   ("GS Token",    0x0F,  0x04, "Death Mountain Trail",   None),
    "GS Mountain Trail Above Dodongo's Cavern":        ("GS Token",    0x0F,  0x08, "Death Mountain Trail",   None),
    "GS Mountain Trail Path to Crater":                ("GS Token",    0x0F,  0x10, "Death Mountain Trail",   None),
    "GS Goron City Center Platform":                   ("GS Token",    0x0F,  0x20, "Goron City",             None),
    "GS Goron City Boulder Maze":                      ("GS Token",    0x0F,  0x40, "Goron City",             None),
    "GS Death Mountain Crater Crate":                  ("GS Token",    0x0F,  0x80, "Death Mountain Crater",  None),
    "GS Kakariko House Under Construction":            ("GS Token",    0x10,  0x08, "Kakariko Village",       None),
    "GS Kakariko Skulltula House":                     ("GS Token",    0x10,  0x10, "Kakariko Village",       None),
    "GS Kakariko Guard's House":                       ("GS Token",    0x10,  0x02, "Kakariko Village",       None),
    "GS Kakariko Tree":                                ("GS Token",    0x10,  0x20, "Kakariko Village",       None),
    "GS Kakariko Watchtower":                          ("GS Token",    0x10,  0x04, "Kakariko Village",       None),
    "GS Kakariko Above Impa's House":                  ("GS Token",    0x10,  0x40, "Kakariko Village",       None),
    "GS Graveyard Wall":                               ("GS Token",    0x10,  0x80, "the Graveyard",          None),
    "GS Graveyard Bean Patch":                         ("GS Token",    0x10,  0x01, "the Graveyard",          None),
    "GS Zora River Ladder":                            ("GS Token",    0x11,  0x01, "Zora's River",           None),
    "GS Zora River Tree":                              ("GS Token",    0x11,  0x02, "Zora's River",           None),
    "GS Zora's Fountain Above the Log":                ("GS Token",    0x11,  0x04, "Zora's Fountain",        None),
    "GS Zora River Above Bridge":                      ("GS Token",    0x11,  0x08, "Zora's River",           None),
    "GS Zora River Near Raised Grottos":               ("GS Token",    0x11,  0x10, "Zora's River",           None),
    "GS Zora's Fountain Hidden Cave":                  ("GS Token",    0x11,  0x20, "Zora's Fountain",        None),
    "GS Zora's Domain Frozen Waterfall":               ("GS Token",    0x11,  0x40, "Zora's Domain",          None),
    "GS Zora's Fountain Tree":                         ("GS Token",    0x11,  0x80, "Zora's Fountain",        None),
    "GS Lake Hylia Bean Patch":                        ("GS Token",    0x12,  0x01, "Lake Hylia",             None),
    "GS Lake Hylia Small Island":                      ("GS Token",    0x12,  0x02, "Lake Hylia",             None),
    "GS Lake Hylia Lab Wall":                          ("GS Token",    0x12,  0x04, "Lake Hylia",             None),
    "GS Lab Underwater Crate":                         ("GS Token",    0x12,  0x08, "Lake Hylia",             None),
    "GS Lake Hylia Giant Tree":                        ("GS Token",    0x12,  0x10, "Lake Hylia",             None),
    "GS Gerudo Valley Bean Patch":                     ("GS Token",    0x13,  0x01, "Gerudo Valley",          None),
    "GS Gerudo Valley Small Bridge":                   ("GS Token",    0x13,  0x02, "Gerudo Valley",          None),
    "GS Gerudo Valley Pillar":                         ("GS Token",    0x13,  0x04, "Gerudo Valley",          None),
    "GS Gerudo Valley Behind Tent":                    ("GS Token",    0x13,  0x08, "Gerudo Valley",          None),
    "GS Gerudo Fortress Archery Range":                ("GS Token",    0x14,  0x01, "Gerudo's Fortress",      None),
    "GS Gerudo Fortress Top Floor":                    ("GS Token",    0x14,  0x02, "Gerudo's Fortress",      None),
    "GS Desert Colossus Bean Patch":                   ("GS Token",    0x15,  0x01, "Desert Colossus",        None),
    "GS Wasteland Ruins":                              ("GS Token",    0x15,  0x02, "Haunted Wasteland",      None),
    "GS Desert Colossus Hill":                         ("GS Token",    0x15,  0x04, "Desert Colossus",        None),
    "GS Desert Colossus Tree":                         ("GS Token",    0x15,  0x08, "Desert Colossus",        None),

    "Kokiri Shop Item 1":                              ("Shop",        0x2D,  0x30, "Kokiri Forest",          (shop_address(0, 0), None)),
    "Kokiri Shop Item 2":                              ("Shop",        0x2D,  0x31, "Kokiri Forest",          (shop_address(0, 1), None)),
    "Kokiri Shop Item 3":                              ("Shop",        0x2D,  0x32, "Kokiri Forest",          (shop_address(0, 2), None)),
    "Kokiri Shop Item 4":                              ("Shop",        0x2D,  0x33, "Kokiri Forest",          (shop_address(0, 3), None)),
    "Kokiri Shop Item 5":                              ("Shop",        0x2D,  0x34, "Kokiri Forest",          (shop_address(0, 4), None)),
    "Kokiri Shop Item 6":                              ("Shop",        0x2D,  0x35, "Kokiri Forest",          (shop_address(0, 5), None)),
    "Kokiri Shop Item 7":                              ("Shop",        0x2D,  0x36, "Kokiri Forest",          (shop_address(0, 6), None)),
    "Kokiri Shop Item 8":                              ("Shop",        0x2D,  0x37, "Kokiri Forest",          (shop_address(0, 7), None)),
    "Kakariko Potion Shop Item 1":                     ("Shop",        0x30,  0x30, "Kakariko Village",       (shop_address(1, 0), None)),
    "Kakariko Potion Shop Item 2":                     ("Shop",        0x30,  0x31, "Kakariko Village",       (shop_address(1, 1), None)),
    "Kakariko Potion Shop Item 3":                     ("Shop",        0x30,  0x32, "Kakariko Village",       (shop_address(1, 2), None)),
    "Kakariko Potion Shop Item 4":                     ("Shop",        0x30,  0x33, "Kakariko Village",       (shop_address(1, 3), None)),
    "Kakariko Potion Shop Item 5":                     ("Shop",        0x30,  0x34, "Kakariko Village",       (shop_address(1, 4), None)),
    "Kakariko Potion Shop Item 6":                     ("Shop",        0x30,  0x35, "Kakariko Village",       (shop_address(1, 5), None)),
    "Kakariko Potion Shop Item 7":                     ("Shop",        0x30,  0x36, "Kakariko Village",       (shop_address(1, 6), None)),
    "Kakariko Potion Shop Item 8":                     ("Shop",        0x30,  0x37, "Kakariko Village",       (shop_address(1, 7), None)),
    "Bombchu Shop Item 1":                             ("Shop",        0x32,  0x30, "the Market",             (shop_address(2, 0), None)),
    "Bombchu Shop Item 2":                             ("Shop",        0x32,  0x31, "the Market",             (shop_address(2, 1), None)),
    "Bombchu Shop Item 3":                             ("Shop",        0x32,  0x32, "the Market",             (shop_address(2, 2), None)),
    "Bombchu Shop Item 4":                             ("Shop",        0x32,  0x33, "the Market",             (shop_address(2, 3), None)),
    "Bombchu Shop Item 5":                             ("Shop",        0x32,  0x34, "the Market",             (shop_address(2, 4), None)),
    "Bombchu Shop Item 6":                             ("Shop",        0x32,  0x35, "the Market",             (shop_address(2, 5), None)),
    "Bombchu Shop Item 7":                             ("Shop",        0x32,  0x36, "the Market",             (shop_address(2, 6), None)),
    "Bombchu Shop Item 8":                             ("Shop",        0x32,  0x37, "the Market",             (shop_address(2, 7), None)),
    "Castle Town Potion Shop Item 1":                  ("Shop",        0x31,  0x30, "the Market",             (shop_address(3, 0), None)),
    "Castle Town Potion Shop Item 2":                  ("Shop",        0x31,  0x31, "the Market",             (shop_address(3, 1), None)),
    "Castle Town Potion Shop Item 3":                  ("Shop",        0x31,  0x32, "the Market",             (shop_address(3, 2), None)),
    "Castle Town Potion Shop Item 4":                  ("Shop",        0x31,  0x33, "the Market",             (shop_address(3, 3), None)),
    "Castle Town Potion Shop Item 5":                  ("Shop",        0x31,  0x34, "the Market",             (shop_address(3, 4), None)),
    "Castle Town Potion Shop Item 6":                  ("Shop",        0x31,  0x35, "the Market",             (shop_address(3, 5), None)),
    "Castle Town Potion Shop Item 7":                  ("Shop",        0x31,  0x36, "the Market",             (shop_address(3, 6), None)),
    "Castle Town Potion Shop Item 8":                  ("Shop",        0x31,  0x37, "the Market",             (shop_address(3, 7), None)),
    "Castle Town Bazaar Item 1":                       ("Shop",        0x2C,  0x30, "the Market",             (shop_address(4, 0), None)),
    "Castle Town Bazaar Item 2":                       ("Shop",        0x2C,  0x31, "the Market",             (shop_address(4, 1), None)),
    "Castle Town Bazaar Item 3":                       ("Shop",        0x2C,  0x32, "the Market",             (shop_address(4, 2), None)),
    "Castle Town Bazaar Item 4":                       ("Shop",        0x2C,  0x33, "the Market",             (shop_address(4, 3), None)),
    "Castle Town Bazaar Item 5":                       ("Shop",        0x2C,  0x34, "the Market",             (shop_address(4, 4), None)),
    "Castle Town Bazaar Item 6":                       ("Shop",        0x2C,  0x35, "the Market",             (shop_address(4, 5), None)),
    "Castle Town Bazaar Item 7":                       ("Shop",        0x2C,  0x36, "the Market",             (shop_address(4, 6), None)),
    "Castle Town Bazaar Item 8":                       ("Shop",        0x2C,  0x37, "the Market",             (shop_address(4, 7), None)),
    "Kakariko Bazaar Item 1":                          ("Shop",        0x2C,  0x38, "Kakariko Village",       (shop_address(5, 0), None)),
    "Kakariko Bazaar Item 2":                          ("Shop",        0x2C,  0x39, "Kakariko Village",       (shop_address(5, 1), None)),
    "Kakariko Bazaar Item 3":                          ("Shop",        0x2C,  0x3A, "Kakariko Village",       (shop_address(5, 2), None)),
    "Kakariko Bazaar Item 4":                          ("Shop",        0x2C,  0x3B, "Kakariko Village",       (shop_address(5, 3), None)),
    "Kakariko Bazaar Item 5":                          ("Shop",        0x2C,  0x3D, "Kakariko Village",       (shop_address(5, 4), None)),
    "Kakariko Bazaar Item 6":                          ("Shop",        0x2C,  0x3E, "Kakariko Village",       (shop_address(5, 5), None)),
    "Kakariko Bazaar Item 7":                          ("Shop",        0x2C,  0x3F, "Kakariko Village",       (shop_address(5, 6), None)),
    "Kakariko Bazaar Item 8":                          ("Shop",        0x2C,  0x40, "Kakariko Village",       (shop_address(5, 7), None)),
    "Zora Shop Item 1":                                ("Shop",        0x2F,  0x30, "Zora's Domain",          (shop_address(7, 0), None)),
    "Zora Shop Item 2":                                ("Shop",        0x2F,  0x31, "Zora's Domain",          (shop_address(7, 1), None)),
    "Zora Shop Item 3":                                ("Shop",        0x2F,  0x32, "Zora's Domain",          (shop_address(7, 2), None)),
    "Zora Shop Item 4":                                ("Shop",        0x2F,  0x33, "Zora's Domain",          (shop_address(7, 3), None)),
    "Zora Shop Item 5":                                ("Shop",        0x2F,  0x34, "Zora's Domain",          (shop_address(7, 4), None)),
    "Zora Shop Item 6":                                ("Shop",        0x2F,  0x35, "Zora's Domain",          (shop_address(7, 5), None)),
    "Zora Shop Item 7":                                ("Shop",        0x2F,  0x36, "Zora's Domain",          (shop_address(7, 6), None)),
    "Zora Shop Item 8":                                ("Shop",        0x2F,  0x37, "Zora's Domain",          (shop_address(7, 7), None)),
    "Goron Shop Item 1":                               ("Shop",        0x2E,  0x30, "Goron City",             (shop_address(8, 0), None)),
    "Goron Shop Item 2":                               ("Shop",        0x2E,  0x31, "Goron City",             (shop_address(8, 1), None)),
    "Goron Shop Item 3":                               ("Shop",        0x2E,  0x32, "Goron City",             (shop_address(8, 2), None)),
    "Goron Shop Item 4":                               ("Shop",        0x2E,  0x33, "Goron City",             (shop_address(8, 3), None)),
    "Goron Shop Item 5":                               ("Shop",        0x2E,  0x34, "Goron City",             (shop_address(8, 4), None)),
    "Goron Shop Item 6":                               ("Shop",        0x2E,  0x35, "Goron City",             (shop_address(8, 5), None)),
    "Goron Shop Item 7":                               ("Shop",        0x2E,  0x36, "Goron City",             (shop_address(8, 6), None)),
    "Goron Shop Item 8":                               ("Shop",        0x2E,  0x37, "Goron City",             (shop_address(8, 7), None)),

    # NPC Scrubs are on the overworld, while GrottoNPC is a special handler for Grottos
    # Grottos scrubs are the same scene and actor, so we use a unique grotto ID for the scene
    "DC Deku Scrub Deku Nuts":                         ("NPC",         0x01,  0x30, "Dodongo's Cavern",       None),
    "DC Deku Scrub Deku Sticks":                       ("NPC",         0x01,  0x31, "Dodongo's Cavern",       None),
    "DC Deku Scrub Deku Seeds":                        ("NPC",         0x01,  0x33, "Dodongo's Cavern",       None),
    "DC Deku Scrub Deku Shield":                       ("NPC",         0x01,  0x34, "Dodongo's Cavern",       None),
    "Jabu Deku Scrub Deku Nuts":                       ("NPC",         0x02,  0x30, "Jabu Jabu's Belly",      None),
    "GC Deku Scrub Bombs":                             ("NPC",         0x0D,  0x37, "Ganon's Castle",         None),
    "GC Deku Scrub Arrows":                            ("NPC",         0x0D,  0x33, "Ganon's Castle",         None),
    "GC Deku Scrub Red Potion":                        ("NPC",         0x0D,  0x39, "Ganon's Castle",         None),
    "GC Deku Scrub Green Potion":                      ("NPC",         0x0D,  0x3A, "Ganon's Castle",         None),
    "DT MQ Deku Scrub Deku Shield":                    ("NPC",         0x00,  0x34, "Deku Tree",              None),
    "DC MQ Deku Scrub Deku Sticks":                    ("NPC",         0x01,  0x31, "Dodongo's Cavern",       None),
    "DC MQ Deku Scrub Deku Seeds":                     ("NPC",         0x01,  0x33, "Dodongo's Cavern",       None),
    "DC MQ Deku Scrub Deku Shield":                    ("NPC",         0x01,  0x34, "Dodongo's Cavern",       None),
    "DC MQ Deku Scrub Red Potion":                     ("NPC",         0x01,  0x39, "Dodongo's Cavern",       None),
    "GC MQ Deku Scrub Deku Nuts":                      ("NPC",         0x0D,  0x30, "Ganon's Castle",         None),
    "GC MQ Deku Scrub Bombs":                          ("NPC",         0x0D,  0x37, "Ganon's Castle",         None),
    "GC MQ Deku Scrub Arrows":                         ("NPC",         0x0D,  0x33, "Ganon's Castle",         None),
    "GC MQ Deku Scrub Red Potion":                     ("NPC",         0x0D,  0x39, "Ganon's Castle",         None),
    "GC MQ Deku Scrub Green Potion":                   ("NPC",         0x0D,  0x3A, "Ganon's Castle",         None),
    "HF Grotto Deku Scrub Piece of Heart":             ("GrottoNPC",   0x01,  0x3E, "Hyrule Field",           None),
    "ZR Grotto Deku Scrub Red Potion":                 ("GrottoNPC",   0x02,  0x39, "Zora's River",           None),
    "ZR Grotto Deku Scrub Green Potion":               ("GrottoNPC",   0x02,  0x3A, "Zora's River",           None),
    "SFM Grotto Deku Scrub Red Potion":                ("GrottoNPC",   0x03,  0x39, "Sacred Forest Meadow",   None),
    "SFM Grotto Deku Scrub Green Potion":              ("GrottoNPC",   0x03,  0x3A, "Sacred Forest Meadow",   None),
    "LH Grotto Deku Scrub Deku Nuts":                  ("GrottoNPC",   0x04,  0x30, "Lake Hylia",             None),
    "LH Grotto Deku Scrub Bombs":                      ("GrottoNPC",   0x04,  0x37, "Lake Hylia",             None),
    "LH Grotto Deku Scrub Arrows":                     ("GrottoNPC",   0x04,  0x33, "Lake Hylia",             None),
    "Valley Grotto Deku Scrub Red Potion":             ("GrottoNPC",   0x05,  0x39, "Gerudo Valley",          None),
    "Valley Grotto Deku Scrub Green Potion":           ("GrottoNPC",   0x05,  0x3A, "Gerudo Valley",          None),
    "LW Deku Scrub Deku Nuts":                         ("NPC",         0x5B,  0x30, "the Lost Woods",         None),
    "LW Deku Scrub Deku Sticks":                       ("NPC",         0x5B,  0x31, "the Lost Woods",         None),
    "LW Deku Scrub Deku Stick Upgrade":                ("NPC",         0x5B,  0x77, "the Lost Woods",         None),
    "LW Grotto Deku Scrub Arrows":                     ("GrottoNPC",   0x06,  0x33, "the Lost Woods",         None),
    "LW Grotto Deku Scrub Deku Nut Upgrade":           ("GrottoNPC",   0x06,  0x79, "the Lost Woods",         None),
    "Desert Grotto Deku Scrub Red Potion":             ("GrottoNPC",   0x07,  0x39, "Desert Colossus",        None),
    "Desert Grotto Deku Scrub Green Potion":           ("GrottoNPC",   0x07,  0x3A, "Desert Colossus",        None),
    "DMC Deku Scrub Bombs":                            ("NPC",         0x61,  0x37, "Death Mountain Crater",  None),
    "DMC Grotto Deku Scrub Deku Nuts":                 ("GrottoNPC",   0x08,  0x30, "Death Mountain Crater",  None),
    "DMC Grotto Deku Scrub Bombs":                     ("GrottoNPC",   0x08,  0x37, "Death Mountain Crater",  None),
    "DMC Grotto Deku Scrub Arrows":                    ("GrottoNPC",   0x08,  0x33, "Death Mountain Crater",  None),
    "Goron Grotto Deku Scrub Deku Nuts":               ("GrottoNPC",   0x09,  0x30, "Goron City",             None),
    "Goron Grotto Deku Scrub Bombs":                   ("GrottoNPC",   0x09,  0x37, "Goron City",             None),
    "Goron Grotto Deku Scrub Arrows":                  ("GrottoNPC",   0x09,  0x33, "Goron City",             None),
    "LLR Grotto Deku Scrub Deku Nuts":                 ("GrottoNPC",   0x0A,  0x30, "Lon Lon Ranch",          None),
    "LLR Grotto Deku Scrub Bombs":                     ("GrottoNPC",   0x0A,  0x37, "Lon Lon Ranch",          None),
    "LLR Grotto Deku Scrub Arrows":                    ("GrottoNPC",   0x0A,  0x33, "Lon Lon Ranch",          None),

    # These are not actual locations, but are filler spots used for hint reachability
    "Death Mountain Crater Gossip Stone":              ("GossipStone", None,  None, None,                     None),
    "Death Mountain Trail Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Desert Colossus Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Dodongos Cavern Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Generic Grotto Gossip Stone":                     ("GossipStone", None,  None, None,                     None),
    "Gerudo Valley Gossip Stone":                      ("GossipStone", None,  None, None,                     None),
    "Goron City Maze Gossip Stone":                    ("GossipStone", None,  None, None,                     None),
    "Goron City Medigoron Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Graveyard Gossip Stone":                          ("GossipStone", None,  None, None,                     None),
    "Hyrule Castle Malon Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Hyrule Castle Rock Wall Gossip Stone":            ("GossipStone", None,  None, None,                     None),
    "Castle Storms Grotto Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Field Valley Grotto Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Deku Tree Gossip Stone (Left)":                   ("GossipStone", None,  None, None,                     None),
    "Deku Tree Gossip Stone (Right)":                  ("GossipStone", None,  None, None,                     None),
    "Kokiri Forest Gossip Stone":                      ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Lab Gossip Stone":                     ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Gossip Stone (Southeast)":             ("GossipStone", None,  None, None,                     None),
    "Lake Hylia Gossip Stone (Southwest)":             ("GossipStone", None,  None, None,                     None),
    "Lost Woods Gossip Stone":                         ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Maze Gossip Stone (Lower)":  ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Maze Gossip Stone (Upper)":  ("GossipStone", None,  None, None,                     None),
    "Sacred Forest Meadow Saria Gossip Stone":         ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Left)":              ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Left-Center)":       ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Right)":             ("GossipStone", None,  None, None,                     None),
    "Temple of Time Gossip Stone (Right-Center)":      ("GossipStone", None,  None, None,                     None),
    "Zoras Domain Gossip Stone":                       ("GossipStone", None,  None, None,                     None),
    "Zoras Fountain Fairy Gossip Stone":               ("GossipStone", None,  None, None,                     None),
    "Zoras Fountain Jabu Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Zoras River Plateau Gossip Stone":                ("GossipStone", None,  None, None,                     None),
    "Zoras River Waterfall Gossip Stone":              ("GossipStone", None,  None, None,                     None),
}

# Business Scrub Details
business_scrubs = [
    # id   price  text   text replacement
    (0x30, 20,   0x10A0, ["Deku Nuts", "a \x05\x42mysterious item\x05\x40"]),
    (0x31, 15,   0x10A1, ["Deku Sticks", "a \x05\x42mysterious item\x05\x40"]),
    (0x3E, 10,   0x10A2, ["Piece of Heart", "\x05\x42mysterious item\x05\x40"]),
    (0x33, 40,   0x10CA, ["\x05\x41Deku Seeds", "a \x05\x42mysterious item"]),
    (0x34, 50,   0x10CB, ["\x41Deku Shield", "\x42mysterious item"]),
    (0x37, 40,   0x10CC, ["\x05\x41Bombs", "a \x05\x42mysterious item"]),
    (0x38, 00,   0x10CD, ["\x05\x41Arrows", "a \x05\x42mysterious item"]),  # unused
    (0x39, 40,   0x10CE, ["\x05\x41Red Potion", "\x05\x42mysterious item"]),
    (0x3A, 40,   0x10CF, ["Green Potion", "mysterious item"]),
    (0x77, 40,   0x10DC, ["enable you to pick up more\x01\x05\x41Deku Sticks", "sell you a \x05\x42mysterious item"]),
    (0x79, 40,   0x10DD, ["enable you to pick up more \x05\x41Deku\x01Nuts", "sell you a \x05\x42mysterious item"]),
]
